"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.buildFragments = void 0;
const index_1 = require("../models/index");
const index_2 = require("../generators/index");
const index_3 = require("../store/index");
const TYPES_TO_PARSE = [index_1.TypeKind.OBJECT, index_1.TypeKind.INTERFACE];
const forbiddenTypes = [index_1.MethodType.Query, index_1.MethodType.Mutation, index_1.MethodType.Subscription];
function buildFragments() {
    const { schemaTypes } = index_3.SchemaStore;
    return schemaTypes
        .map((type) => {
        if (TYPES_TO_PARSE.includes(type.kind) && !forbiddenTypes.includes(type.name)) {
            const isConnection = index_3.SchemaStore.isTypeConnection(type.name);
            const fragment = index_2.generateNormalFragment(type, isConnection);
            if (fragment) {
                return `export const ${type.name}Fragment = sgtsQL\` 
  fragment ${type.name}Fragment on ${type.name} {
    ${fragment}
  }
\`;`;
            }
        }
    })
        .filter((value) => !!value);
}
exports.buildFragments = buildFragments;
