"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.buildSchemaTypes = void 0;
const index_1 = require("../models/index");
const index_2 = require("../generators/index");
const index_3 = require("../store/index");
const OBJECT_TYPES = [index_1.TypeKind.OBJECT, index_1.TypeKind.INTERFACE, index_1.TypeKind.INPUT_OBJECT];
function buildSchemaTypes() {
    const { schemaTypes } = index_3.SchemaStore;
    return schemaTypes.map((type) => {
        if (OBJECT_TYPES.includes(type.kind)) {
            return index_2.getObjectTSInterfaces(type, type.kind === index_1.TypeKind.INPUT_OBJECT);
        }
        else if (type.kind === index_1.TypeKind.UNION) {
            return index_2.generateUnionType(type);
        }
        else if (type.kind === index_1.TypeKind.ENUM) {
            return index_2.generateEnumType(type);
        }
        else {
            return '';
        }
    });
}
exports.buildSchemaTypes = buildSchemaTypes;
