"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.sgtsGenerate = void 0;
require('module-alias/register');
const chalk_1 = __importDefault(require("chalk"));
const index_1 = require("./utilities/index");
const index_2 = require("./save/index");
const index_3 = require("./store/index");
async function sgtsGenerate({ endpoint, json, output, customScalars, header, jsMode, download, ...rest }) {
    console.log(`\n Sgts v${require("../package").version}`);
    try {
        const introspectionSchema = await index_1.retrieveIntrospectionSchema({
            endpoint,
            header,
            json,
            download,
        });
        if (introspectionSchema) {
            index_3.SchemaStore.setSchema(introspectionSchema);
            index_3.ParametersStore.setParamaters({
                scalars: customScalars,
                ...rest,
            });
            const generatedString = index_3.OutputStore.getRenderedFileString();
            return await index_2.saveFile(generatedString, output, jsMode);
        }
        else {
            console.warn(chalk_1.default.yellow('\n ⚠️ You need to either provite a source url or a path to your json schema file'));
        }
    }
    catch (e) {
        console.error(chalk_1.default.red(e));
        return Promise.reject(e);
    }
}
exports.sgtsGenerate = sgtsGenerate;
